| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
EM::PolygonBody Class Reference
EarthModel

A Surface polygon Body. More...

`#include <empolygonbody.h>`

Inheritance diagram for EM::PolygonBody:
[legend]

## Public Member Functions
| PolygonBody (EM::EMManager &)
ImplicitBody * | createImplicitBody (TaskRunner *, bool) const override
void | fillBodyPar (IOPar &) const override
| Should be mapped to EMObject::fillPar;.
const PolygonBodyGeometry & | geometry () const override
PolygonBodyGeometry & | geometry () override
bool | getBodyRange (TrcKeyZSampling &) override
const char * | getTypeStr () const override
uiString | getUserTypeStr () const override
Executor * | loader () override
void | refBody () override
| Should be mapped to EMObject::ref()
Executor * | saver () override
Executor * | saver (IOObj *) override
void | setNewName () override
MultiID | storageID () const override
BufferString | storageName () const override
const char * | type () const override
void | unRefBody () override
| Should be mapped to EMObject::unRef()
bool | useBodyPar (const IOPar &) override
| Should be mapped to EMObject::usePar;.
Public Member Functions inherited from EM::Surface
virtual void | apply (const Pos::Filter &)
EMObjectIterator * | createIterator (const TrcKeyZSampling *=nullptr) const override
const char * | dbInfo () const
bool | enableGeometryChecks (bool) override
void | fillPar (IOPar &) const override
bool | isAtEdge (const EM::PosID &) const override
bool | isGeometryChecksEnabled () const override
bool | isLoaded () const override
Executor * | loader () override
virtual void | removeAll ()
Executor * | saver () override
void | setDBInfo (const char *s)
bool | usePar (const IOPar &) override
Public Member Functions inherited from EM::EMObject
virtual void | addPosAttrib (int attr)
virtual int | addPosAttribName (const char *)
bool | canSetSectionName () const
void | changePosID (const EM::PosID &from, const EM::PosID &to, bool addtohistory)
EMObjectIterator * | createIterator (const EM::SectionID &, const TrcKeyZSampling *t=0) const
void | emptyRemovedPolySelectedPosBox ()
uiString | errMsg () const
virtual void | fillDisplayPar (IOPar &) const
Geometry::Element * | geometryElement ()
const Geometry::Element * | geometryElement () const
virtual void | getLinkedPos (const EM::PosID &posid, TypeSet< EM::PosID > &) const
virtual const OD::Color & | getLockColor () const
virtual const Array2D< char > * | getLockedNodes () const
virtual Coord3 | getPos (const EM::PosID &) const
Coord3 | getPos (const EM::SectionID &, const EM::SubID &subid) const
virtual Coord3 | getPos (const EM::SubID &) const
const TypeSet< PosID > * | getPosAttribList (int attr) const
const MarkerStyle3D & | getPosAttrMarkerStyle (int attr) const
const TrcKeyZSampling | getRemovedPolySelectedPosBox ()
const OD::Color & | getSelectionColor () const
Interval< float > | getZRange (bool compute_if_needed=false) const
bool | hasBurstAlert () const
virtual bool | hasLockedNodes () const
virtual bool | hasNodeSourceType (const PosID &) const
virtual bool | hasPosAttrib (int attr) const
const ObjectID & | id () const
virtual bool | isChanged () const
virtual bool | isDefined (const EM::PosID &) const
bool | isDefined (const EM::SectionID &, const EM::SubID &subid) const
virtual bool | isDefined (const EM::SubID &) const
virtual bool | isEmpty () const
bool | isFullyLoaded () const
bool | isInsideSelRemoval () const
virtual bool | isLocked () const
virtual bool | isNodeLocked (const PosID &) const
virtual bool | isNodeLocked (const TrcKey &) const
virtual bool | isNodeSourceType (const PosID &, NodeSourceType) const
virtual bool | isNodeSourceType (const TrcKey &, NodeSourceType) const
virtual bool | isOK () const
virtual bool | isPosAttrib (const EM::PosID &, int attr) const
virtual bool | isPosAttribLocked (int attr) const
bool | isSelRemoving () const
bool | isZInDepth () const
virtual void | lock (bool yn)
virtual void | lockAll ()
virtual void | lockPosAttrib (int attr, bool yn)
const MultiID & | multiID () const
virtual int | nrPosAttribs () const
int | nrSections () const
virtual int | posAttrib (int idx) const
virtual const char * | posAttribName (int) const
const OD::Color & | preferredColor () const
const OD::LineStyle & | preferredLineStyle () const
void | removeAllUnSeedPos ()
void | removeListOfSubIDs (const TypeSet< EM::SubID > &)
void | removeListOfSubIDs (const TypeSet< EM::SubID > &, const EM::SectionID &)
virtual void | removePosAttribList (int attr, bool addtohistory=true)
bool | removeSection (SectionID, bool hist)
virtual void | removeSelected (const Selector< Coord3 > &, TaskRunner *)
void | removeSelected (const TypeSet< EM::SubID > &)
virtual void | resetChangedFlag ()
void | saveDisplayPars () const
Geometry::Element * | sectionGeometry (const SectionID &)
const Geometry::Element * | sectionGeometry (const SectionID &) const
SectionID | sectionID (int) const
int | sectionIndex (const SectionID &) const
BufferString | sectionName (const SectionID &) const
void | setBurstAlert (bool yn)
virtual void | setChangedFlag ()
void | setErrMsg (const uiString &m)
void | setFullyLoaded (bool yn)
virtual void | setLockColor (const OD::Color &)
void | setMultiID (const MultiID &)
virtual void | setNodeLocked (const TrcKey &, bool locked)
virtual void | setNodeSourceType (const TrcKey &, NodeSourceType)
virtual bool | setPos (const EM::PosID &, const Coord3 &, bool addtohistory)
bool | setPos (const EM::SectionID &, const EM::SubID &subid, const Coord3 &crd, bool addtohistory)
virtual bool | setPos (const EM::SubID &, const Coord3 &, bool addtohistory)
virtual void | setPosAttrib (const EM::PosID &, int attr, bool yn, bool addtohistory=true)
| Sets/unsets the posattrib depending on yn.
void | setPosAttrMarkerStyle (int attr, const MarkerStyle3D &)
void | setPreferredColor (const OD::Color &, bool addtohistory=false)
void | setPreferredLineStyle (const OD::LineStyle &)
bool | setSectionName (const SectionID &, const char *, bool addtohistory)
void | setSelectionColor (const OD::Color &)
EMObject & | setZDomain (const ZDomain::Info &)
mDeprecatedDef uiString | uiName () const
virtual void | unlockAll ()
virtual bool | unSetPos (const EM::PosID &, bool addtohistory)
bool | unSetPos (const EM::SectionID &, const EM::SubID &subid, bool addtohistory)
virtual bool | unSetPos (const EM::SubID &, bool addtohistory)
virtual bool | useDisplayPar (const IOPar &)
const ZDomain::Info & | zDomain () const
const UnitOfMeasure * | zUnit () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const
Public Member Functions inherited from EM::Body
virtual | ~Body ()
const IOObjContext & | getBodyContext () const

## Static Public Member Functions
static PolygonBody * | create (const char *nm)
static EMObject * | create (EM::EMManager &)
static void | initClass ()
static StringView | typeStr ()
Static Public Member Functions inherited from EM::Surface
static BufferString | getParentChildFileName (const IOObj &)
static BufferString | getParFileName (const IOObj &)
static BufferString | getSetupFileName (const IOObj &)
Static Public Member Functions inherited from EM::EMObject
static int | sEdgeControlNode ()
static int | sIntersectionNode ()
static int | sPermanentControlNode ()
static int | sSeedNode ()
static int | sTemporaryControlNode ()
static int | sTerminationNode ()
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Protected Member Functions
| ~PolygonBody ()
const IOObjContext & | getIOObjContext () const override
Protected Member Functions inherited from EM::Surface
| Surface (EMManager &)
| ~Surface ()
Geometry::Element * | geometryElementInternal () override
Geometry::Element * | sectionGeometryInternal (const SectionID &) override
Protected Member Functions inherited from EM::EMObject
| EMObject (EMManager &)
| must be called after creation
| ~EMObject ()
void | posIDChangeCB (CallBacker *)
const MarkerStyle3D & | preferredMarkerStyle3D () const
virtual void | prepareForDelete () const
void | prepareForDelete () override
void | setPreferredMarkerStyle3D (const MarkerStyle3D &)
void | useDisplayPars (const IOPar &)
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)
Protected Member Functions inherited from EM::Body
| Body ()

## Protected Attributes
PolygonBodyGeometry | geometry_
Protected Attributes inherited from EM::Surface
BufferString | dbinfo
Protected Attributes inherited from EM::EMObject
TypeSet< int > | attribs_
int | burstalertcount_ = 0
bool | changed_ = false
uiString | errmsg_
bool | fullyloaded_ = false
bool | haslockednodes_ = false
ObjectID | id_
bool | insideselremoval_ = false
OD::Color | lockcolor_
bool | locked_ = false
class EMManager & | manager_
BufferString | objname_
MarkerStyle3D & | posattribmarkerstyle_
ObjectSet< PosAttrib > | posattribs_
OD::Color & | preferredcolor_
OD::LineStyle & | preferredlinestyle_
MarkerStyle3D & | preferredmarkerstyle_
TrcKeyZSampling | removebypolyposbox_
OD::Color | selectioncolor_
bool | selremoving_ = false
Threads::Lock | setposlock_
MultiID | storageid_
const ZDomain::Info * | zdominfo_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Friends
class | EMManager
class | EMObject

## Additional Inherited Members
Public Types inherited from EM::EMObject
enum | NodeSourceType { None = (int)'0' , Manual =(int)'1' , Auto =(int)'2' , Gridding =(int)'3' }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Public Attributes inherited from EM::EMObject
CNotifier< EMObject, const EMObjectCallbackData & > | change
Static Protected Member Functions inherited from EM::EMObject
static const char * | nrposattrstr ()
static const char * | posattrposidstr ()
static const char * | posattrprefixstr ()
static const char * | posattrsectionstr ()

## Detailed Description

A Surface polygon Body.

<>

## Constructor & Destructor Documentation

## ◆ PolygonBody()

EM::PolygonBody::PolygonBody | ( | EM::EMManager & |  | ) |

## ◆ ~PolygonBody()

EM::PolygonBody::~PolygonBody | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create() [1/2]

static PolygonBody * EM::PolygonBody::create | ( | const char * | nm | ) |
| static

## ◆ create() [2/2]

static EMObject * EM::PolygonBody::create | ( | EM::EMManager & |  | ) |
| static

## ◆ createImplicitBody()

ImplicitBody * EM::PolygonBody::createImplicitBody | ( | TaskRunner * | ,
|  | bool | ) const
| override virtual

Reimplemented from EM::Body.

## ◆ fillBodyPar()

void EM::PolygonBody::fillBodyPar | ( | IOPar & |  | ) | const
| override virtual

Should be mapped to EMObject::fillPar;.

Implements EM::Body.

## ◆ geometry() [1/2]

const PolygonBodyGeometry & EM::PolygonBody::geometry | ( |  | ) | const
| override virtual

Reimplemented from EM::Surface.

## ◆ geometry() [2/2]

PolygonBodyGeometry & EM::PolygonBody::geometry | ( |  | ) |
| override virtual

Implements EM::Surface.

## ◆ getBodyRange()

bool EM::PolygonBody::getBodyRange | ( | TrcKeyZSampling & |  | ) |
| override virtual

Implements EM::Body.

## ◆ getIOObjContext()

const IOObjContext & EM::PolygonBody::getIOObjContext | ( |  | ) | const
| override protected virtual

Implements EM::EMObject.

## ◆ getTypeStr()

const char * EM::PolygonBody::getTypeStr | ( |  | ) | const
| override virtual

Implements EM::EMObject.

## ◆ getUserTypeStr()

uiString EM::PolygonBody::getUserTypeStr | ( |  | ) | const
| inline override virtual

Implements EM::EMObject.

## ◆ initClass()

static void EM::PolygonBody::initClass | ( |  | ) |
| static

## ◆ loader()

Executor * EM::PolygonBody::loader | ( |  | ) |
| override virtual

Reimplemented from EM::EMObject.

## ◆ refBody()

void EM::PolygonBody::refBody | ( |  | ) |
| override virtual

Should be mapped to EMObject::ref()

Implements EM::Body.

## ◆ saver() [1/2]

Executor * EM::PolygonBody::saver | ( |  | ) |
| override virtual

Reimplemented from EM::EMObject.

## ◆ saver() [2/2]

Executor * EM::PolygonBody::saver | ( | IOObj * |  | ) |
| override virtual

Reimplemented from EM::Surface.

## ◆ setNewName()

void EM::PolygonBody::setNewName | ( |  | ) |
| override virtual

Reimplemented from EM::EMObject.

## ◆ storageID()

MultiID EM::PolygonBody::storageID | ( |  | ) | const
| override virtual

Implements EM::Body.

## ◆ storageName()

BufferString EM::PolygonBody::storageName | ( |  | ) | const
| override virtual

Implements EM::Body.

## ◆ type()

const char * EM::PolygonBody::type | ( |  | ) | const
| inline override virtual

Implements EM::Body.

## ◆ typeStr()

static StringView EM::PolygonBody::typeStr | ( |  | ) |
| static

## ◆ unRefBody()

void EM::PolygonBody::unRefBody | ( |  | ) |
| override virtual

Should be mapped to EMObject::unRef()

Implements EM::Body.

## ◆ useBodyPar()

bool EM::PolygonBody::useBodyPar | ( | const IOPar & |  | ) |
| override virtual

Should be mapped to EMObject::usePar;.

Reimplemented from EM::Body.

## Friends And Related Symbol Documentation

## ◆ EMManager

friend class EMManager
| friend

## ◆ EMObject

friend class EMObject
| friend

## Member Data Documentation

## ◆ geometry_

PolygonBodyGeometry EM::PolygonBody::geometry_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025